/*
 * Copyright (C) 2015-2019 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana
 *
 * This file is part of blendb.
 *
 * blendb is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * blendb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with blendb.  If not, see <http://www.gnu.org/licenses/>.
 */

import * as json2csv from "json-2-csv";
import { Middleware } from "../types";

/**
 * Creates a csv parser and middleaew that
 * inserts the parser into the request objects.
 */
export function CsvMw(): Middleware {
    return function csvMiddleware(req, res, next) {
        req.csvParser = function parseCsv(json: any, format: string, cb) {
            const separator = format.substring(0, 1);

            let sep = ",";
            if (separator === "s") {
                sep = ";";
            }

            else if (separator === "t"){
                sep = "\t";
            }

            json2csv.json2csv(json, cb, {
                delimiter: {
                    field: sep
                    , wrap: "\""
                    , eol: "\n"
                }
                , prependHeader: true
            });
        };
        next();
    };

}
